/* 
 * This file is part of the dcload Dreamcast serial loader
 *
 * Copyright (C) 2001 Andrew Kieschnick <andrewk@napalm-x.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */

/********************************************************
 * Win32 port and transmission fixes by NickK 8/22/2002 *
 ********************************************************/

#ifndef __DC_TOOL_H
#define __DC_TOOL_H

#include <stdio.h>
#include <windows.h>
#include <time.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <fcntl.h>
#include <io.h>
#include "minilzo.106/minilzo.h"
#include "bfd.h"
#include "BiDiList.h"

#define DCLOAD_BUFFER 8192
#define SERIAL_DEVICE "COM1"
#define BAUD_RATE     57600
#define DATA_BITS     8
#define PARITY_SET    NOPARITY
#define STOP_BITS     ONESTOPBIT

#define VERSION "1.0.3 Win32 Release 1"

#pragma comment(lib, "libbfd-2.10.91.lib")
#pragma comment(lib, "BiDiList.lib")

//From dc-tool.c:

//From dc-tool_io.c:
HANDLE openSerialPort(char *portName, unsigned long baudRate);
void   closeSerialPort(HANDLE hCommPort);
int    changeSerialPortSpeed(HANDLE hCommPort, unsigned long baudRate,
                             unsigned char speedHack);
int    serialRead(HANDLE hCommPort, void *buffer, int count);
int    serialWrite(HANDLE hCommPort, void *buffer, int count);
int    sendUInt(HANDLE hCommPort, unsigned int value);
int    recvUInt(HANDLE hCommPort, unsigned int *value);
int    recvData(HANDLE hCommPort, void *data, unsigned int total,
                unsigned int verbose);
int    sendData(HANDLE hCommPort, unsigned char *addr, unsigned int size,
                unsigned int verbose);
void   outputError(void);

//From syscalls.c:
void dcLoadSysCallsInit(void);
void dcLoadSysCallsShutdown(void);
void dcFStat(HANDLE hCommPort);
void dcWrite(HANDLE hCommPort);
void dcRead(HANDLE hCommPort);
void dcOpen(HANDLE hCommPort);
void dcClose(HANDLE hCommPort);
void dcCreate(HANDLE hCommPort);
void dcLink(HANDLE hCommPort);
void dcUnlink(HANDLE hCommPort);
void dcChdir(HANDLE hCommPort);
void dcChmod(HANDLE hCommPort);
void dcLSeek(HANDLE hCommPort);
void dcTime(HANDLE hCommPort);
void dcStat(HANDLE hCommPort);
void dcUTime(HANDLE hCommPort);
void dcReadDir(HANDLE hCommPort);
void dcOpenDir(HANDLE hCommPort);
void dcCloseDir(HANDLE hCommPort);
void dcReadDir(HANDLE hCommPort);
void dcCDFSRedirReadSectors(HANDLE hCommPort, FILE *f);

#endif